[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Diff for /openbsd/update_openbsd/update_openbsd between version 1.39 and 1.70

version 1.39, 2012/12/08 19:52:08 version 1.70, 2015/01/18 02:59:23
Line 1 
Line 1 
 #!/bin/sh  #!/bin/sh
 # $AFresh1: update_openbsd,v 1.38 2012/04/19 04:03:47 andrew Exp $  # $AFresh1: update_openbsd,v 1.69 2014/10/18 23:05:49 andrew Exp $
   #
   # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   #
   
 installed_sets() {  installed_sets() {
     local misc=/usr/share/doc/README      local misc=/usr/share/doc/README
     local man=/usr/share/man/cat1/intro.0      local man=/usr/share/man/man1/intro.1
     local comp=/usr/bin/cc      local comp=/usr/bin/cc
     local game=/usr/games/      local game=/usr/games/
     local xbase=/usr/X11R6/      local xbase=/usr/X11R6/
Line 142 
Line 157 
     fi      fi
   
     if [ X"" == X"${_v}" ]; then      if [ X"" == X"${_v}" ]; then
         echo ERROR: Unable to determine file version! >&2          if [ X"" == X"${MIRROR}" ]; then
               echo ERROR: No sets, and no MIRROR, unable to continue. >&2
           else
               echo ERROR: Unable to determine FILE_VER, check your MIRROR. >&2
           fi
         return 1          return 1
     fi      fi
   
Line 160 
Line 179 
         [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \          [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
             s///; s/^.*://; s/ .*$//' /boot.conf \              s///; s/^.*://; s/ .*$//' /boot.conf \
     ) | tail -1`      ) | tail -1`
       BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`
     BOOT_KERNEL="/${BOOT_KERNEL#/}"      BOOT_KERNEL="/${BOOT_KERNEL#/}"
     BOOT_KERNEL=`follow_symlink $BOOT_KERNEL`  
   
     BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`      BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`
   
Line 170 
Line 189 
   
     # We want to default to what we had      # We want to default to what we had
     INSTALL_KERNELS="${BOOT_KERNEL#/}"      INSTALL_KERNELS="${BOOT_KERNEL#/}"
       # if the boot kernel was our specially named bsd.sp, we install from bsd
       if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
           INSTALL_KERNELS="bsd"
       fi
     # with a second option of an mp kernel if is is a likely candidate      # with a second option of an mp kernel if is is a likely candidate
     if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then      if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then
         local _ncpu=$(sysctl -n hw.ncpufound)          local _ncpu=$(sysctl -n hw.ncpufound)
Line 184 
Line 207 
 }  }
   
 get_sets() {  get_sets() {
     echo '### GETTING SETS ###'      echo '==> GETTING SETS'
     if [ X"" == X"$FTP" ]; then      if [ X"" == X"$FTP" ]; then
         echo ERROR: No FTP site set! >&2          echo ERROR: No FTP site set! >&2
         return 1          return 1
Line 196 
Line 219 
     local _v=$FILE_VER      local _v=$FILE_VER
   
     for _b in $INSTALL_KERNELS; do      for _b in $INSTALL_KERNELS; do
         if [ -e /${_b} -a ! -e ./${_b} ]; then          if [ ! -e ./${_b} ]; then
             echo $FTP_CMD ${FTP}/${_b}              echo "===> $FTP_CMD ${FTP}/${_b}"
             $FTP_CMD ${FTP}/${_b}              $FTP_CMD ${FTP}/${_b}
           else
               echo "===> Have ${_b}"
         fi          fi
           kernel_file_version "${_b}"
     done      done
   
     for _s in $INSTALLED_SETS; do      for _s in $INSTALLED_SETS; do
Line 209 
Line 235 
         fi          fi
   
         if [ ! -e ./${_file} ]; then          if [ ! -e ./${_file} ]; then
             echo $FTP_CMD ${FTP}/${_file}              echo "===> $FTP_CMD ${FTP}/${_file}"
             $FTP_CMD ${FTP}/${_file}              $FTP_CMD ${FTP}/${_file}
         fi          fi
     done      done
   
     local _type      local _type
       local _ftp
     for _type in $CHECKSUM_TYPES; do      for _type in $CHECKSUM_TYPES; do
         if [ ! -e $_type ]; then          [ -e $_type ] && break
             echo $FTP_CMD ${FTP}/$_type          _ftp=`echo "$FTP" | sed -e 's,://[^/]*/,://ftp.openbsd.org/,'`
             $FTP_CMD ${FTP}/$_type          echo "===> $FTP_CMD ${_ftp}/$_type"
         fi          $FTP_CMD ${_ftp}/$_type
     done      done
 }  }
   
Line 237 
Line 264 
   
 check_sum () {  check_sum () {
     local _type=$1      local _type=$1
     echo "### CHECKING $_type SUMS ###"      echo "==> CHECKING $_type SUMS"
     cd $RELEASEDIR      cd $RELEASEDIR
   
     if [ ! -e $_type ]; then      if [ ! -e $_type ]; then
Line 245 
Line 272 
         return 1          return 1
     fi      fi
   
     ls bsd* *gz | sed -e 's/\(.*\)/(\1)/' > index      local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     grep -f index $_type | sum -c      local _signify=`which signify 2>/dev/null`
       local _keyfile=/etc/signify/openbsd-${_nv}-base.pub
       local _b _s
   
       (
           for _b in $INSTALL_KERNELS; do echo "($_b)"        ; done
           for _s in $INSTALLED_SETS;  do echo "($_s$_nv.tgz)"; done
       ) > index
   
   
       if [ -n "$_signify" -a "$_type" != "${_type%.sig}" ]; then
           echo "===> Checking signature";
           if [ ! -e $_keyfile ]; then
               echo "key [$_keyfile] does not exist, cannot check $_type" >&2
               return 2
           fi
           signify -V -e -p $_keyfile -x $_type -m - | grep -f index | sha256 -c -
       else
          grep -f index $_type | sum -c
       fi
   
     if [ $? -ne 0 ]; then      if [ $? -ne 0 ]; then
         echo ERROR: $_type does not match! >&2          echo ERROR: $_type does not match! >&2
         return 1          return 1
Line 255 
Line 301 
 }  }
   
 check_sets() {  check_sets() {
     echo '### CHECKING SETS ###'      echo '==> CHECKING SETS'
     cd $RELEASEDIR      cd $RELEASEDIR
   
     local _missing_sets      local _missing_sets
Line 291 
Line 337 
     done      done
   
     if [ X"" == X"${_missing_sets}" ]; then      if [ X"" == X"${_missing_sets}" ]; then
         echo All OK          echo '===> All OK'
     fi      fi
   
     local _type      local _type
     for _type in $CHECKSUM_TYPES; do      for _type in $CHECKSUM_TYPES; do
         if [ -e $_type ]; then          if [ -e $_type ]; then
             check_sum $_type              check_sum $_type && break
               [ -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1
         fi          fi
     done      done
   
       return 0
 }  }
   
   
 install_kernels() {  install_kernels() {
     echo '### INSTALLING KERNEL ###'      echo '==> INSTALLING KERNEL'
     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then  
         echo ${0##*/} must be run as root or SUDO must be set! >&2  
         exit 1  
     fi  
   
     if [ X"" == X"$RELEASEDIR" ]; then      if [ X"" == X"$RELEASEDIR" ]; then
         echo ERROR: no source for new kernels! >&2          echo ERROR: no source for new kernels! >&2
         exit 1          exit 1
     fi      fi
   
     echo "Backing up $BOOT_KERNEL to /obsd"      if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
     $SUDO ln -f $BOOT_KERNEL /obsd          echo "===> Backing up $BOOT_KERNEL to /obsd"
     if [ $? -ne 0 ]; then          ln -f $BOOT_KERNEL /obsd
         echo "Error copying old kernel!" >&2          if [ $? -ne 0 ]; then
         exit 1              echo "Error copying old kernel!" >&2
               exit 1
           fi
     fi      fi
   
     cd $RELEASEDIR      cd $RELEASEDIR
   
     for _b in $INSTALL_KERNELS; do      for _b in $INSTALL_KERNELS; do
         $SUDO rm -f /nbsd          rm -f /nbsd
         local _bd=$_b          local _bd=$_b
         [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"          [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
   
         local _is_boot=""          local _is_boot=""
         [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"          [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"
   
         echo "Copying $_b to /$_bd $_is_boot"          echo "===> Copying $_b to /$_bd $_is_boot"
         $SUDO cp ${_b} /nbsd && $SUDO mv /nbsd /${_bd}          cp ${_b} /nbsd && mv /nbsd /${_bd}
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo ERROR: Could not copy new $_bd kernel! >&2              echo ERROR: Could not copy new $_bd kernel! >&2
             exit 1              exit 1
Line 347 
Line 394 
         for _b in $BOOT_KERNELS; do          for _b in $BOOT_KERNELS; do
             [ X"$_b" == X"bsd" ] && _b="bsd.sp"              [ X"$_b" == X"bsd" ] && _b="bsd.sp"
             if [ -e $_b ]; then              if [ -e $_b ]; then
                 echo symlinking $_b to /bsd                  echo "===> symlinking $_b to /bsd"
                 $SUDO ln -sf $_b bsd                  ln -sf $_b bsd
                 if [ $? -ne 0 ]; then                  if [ $? -ne 0 ]; then
                     echo ERROR: Could not symlink new kernel! >&2                      echo ERROR: Could not symlink new kernel! >&2
                     exit 1                      exit 1
Line 361 
Line 408 
 }  }
   
 install_sets() {  install_sets() {
     echo '### INSTALLING SETS ###'      echo '==> INSTALLING SETS'
     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then  
         echo ${0##*/} must be run as root or SUDO must be set! >&2  
         exit 1  
     fi  
   
     if [ X"" == X"$RELEASEDIR" ]; then      if [ X"" == X"$RELEASEDIR" ]; then
         echo ERROR: no source for sets! >&2          echo ERROR: no source for sets! >&2
Line 376 
Line 419 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
     if [ $CUR_VER != $NEW_VER -a ! -e /sbin/oreboot ]; then  
         $SUDO cp /sbin/reboot /sbin/oreboot  
         if [ $? -ne 0 ]; then  
             echo "Error copying old reboot command!" >&2  
             exit 1  
         fi  
         echo "/sbin/reboot copied to /sbin/oreboot"  
     fi  
   
     local _sets=`ls *${_v}.tgz | grep -v ^base `      local _sets=`ls *${_v}.tgz | grep -v ^base `
     for _f in ${_sets} base${_v}.tgz; do      for _f in ${_sets} base${_v}.tgz; do
         _path=$DESTDIR          _path=$DESTDIR
Line 394 
Line 428 
             _path=/var/tmp/temproot              _path=/var/tmp/temproot
         fi          fi
   
         echo Extracting $_f to $_path          echo "===> Extracting $_f to $_path"
         $SUDO mkdir -p $_path          mkdir -p $_path
         $SUDO tar -C $_path -xzphf ${RELEASEDIR}/${_f}          tar -C $_path -xzphf ${RELEASEDIR}/${_f}
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo ERROR: Could not extract ${_f}! >&2              echo ERROR: Could not extract ${_f}! >&2
             exit 1              exit 1
         fi          fi
     done      done
   
     echo Extracted all sets.      echo '===> Extracted all sets.'
   }
   
   install_sendmail_smtp_auth() {
     if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then      if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then
         gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \          gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \
             ${RELEASEDIR}/sendmail-smtp_auth              ${RELEASEDIR}/sendmail-smtp_auth
     fi      fi
     if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then      if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then
         if ! pkg_info -qe 'cyrus-sasl-*'; then          if ! pkg_info -qe 'cyrus-sasl-*'; then
             $SUDO pkg_add -i cyrus-sasl              pkg_add -i cyrus-sasl
         fi          fi
   
         $SUDO install -o root -g smmsp -m 2555 \          install -o root -g smmsp -m 2555 \
             ${RELEASEDIR}/sendmail-smtp_auth \              ${RELEASEDIR}/sendmail-smtp_auth \
             /usr/libexec/sendmail/sendmail              /usr/libexec/sendmail/sendmail
   
         echo Installed sendmail with smtp_auth          echo '===> Installed sendmail with smtp_auth'
     fi      fi
 }  }
   
 update_etc() {  update_etc() {
     echo '### UPDATING ETC ###'      echo '==> UPDATING ETC'
     if [ ! -e $SYSMERGE ]; then      if [ ! -e $SYSMERGE ]; then
         SYSMERGE=          echo "ERROR: Can't find sysmerge!" >&2
           exit 1;
     fi      fi
   
     if [ X"" == X"$SYSMERGE" ]; then      local _v=$FILE_VER
         if [ -e /var/tmp/temproot ]; then      local _args=""
             MERGEMASTER=`which mergemaster`  
   
             if [ $? != 0 ]; then      if [ ! -e /usr/share/sysmerge/etc.tgz ]; then
                 $SUDO pkg_add -i mergemaster  
   
                 MERGEMASTER=`which mergemaster`  
                 if [ $? != 0 ]; then  
                     echo ERROR: mergemaster not installed! >&2  
                     exit 1  
                 fi  
             fi  
   
             echo '### RUNNING MERGEMASTER ###'  
             $SUDO $MERGEMASTER -irv  
         else  
             echo "ERROR: no source for etc!" >&2  
             exit 1  
         fi  
     else  
         if [ X"" == X"$RELEASEDIR" ]; then          if [ X"" == X"$RELEASEDIR" ]; then
             echo "ERROR: no source for etc!" >&2              echo "ERROR: no source for etc!" >&2
             exit 1              exit 1
         else  
             cd $RELEASEDIR  
         fi          fi
   
         local _v=$FILE_VER          cd $RELEASEDIR
         local _args=""  
         if [ -e etc${_v}.tgz ]; then          if [ -e etc${_v}.tgz ]; then
             _args="$_args -s etc${_v}.tgz"              _args="$_args -s ${RELEASEDIR}/etc${_v}.tgz"
         fi          fi
         if [ -e xetc${_v}.tgz ]; then          if [ -e xetc${_v}.tgz ]; then
             _args="$_args -x xetc${_v}.tgz"              _args="$_args -x ${RELEASEDIR}/xetc${_v}.tgz"
         fi          fi
         if [ X"" == X"$_args" ]; then          if [ X"" == X"$_args" ]; then
             echo ERROR: No upgrade sets found! >&2              echo ERROR: No upgrade sets found! >&2
         else              exit 1
             echo '### RUNNING SYSMERGE ###'  
             if sysmerge 2>&1 | grep -- -a >/dev/null; then  
                 _args="-a $_args"  
             fi  
             $SUDO $SYSMERGE $_args  
         fi          fi
     fi      fi
   
       echo '==> RUNNING SYSMERGE'
       $SYSMERGE $_args
   
       cd $OLDPWD
 }  }
   
   
   if [ $(id -u) != 0 ]; then
       echo 'ERROR: need root privileges to run this script' >&2
       exit 1
   fi
   
 if [ -e /etc/update_openbsd.conf ]; then  if [ -e /etc/update_openbsd.conf ]; then
     . /etc/update_openbsd.conf      . /etc/update_openbsd.conf
 fi  fi
Line 495 
Line 518 
   
 INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}  INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
   
 CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256 MD5}  CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256.sig SHA256}
   
 set_version  set_version
 local _error=$?  local _error=$?
Line 504 
Line 527 
 echo "-= update_openbsd - helper script to update OpenBSD =-"  echo "-= update_openbsd - helper script to update OpenBSD =-"
 echo "------------------------------------------------------"  echo "------------------------------------------------------"
 echo  echo
 echo "           SUDO: $SUDO"  
 echo "       SYSMERGE: $SYSMERGE"  echo "       SYSMERGE: $SYSMERGE"
 echo "         MIRROR: $MIRROR"  echo "         MIRROR: $MIRROR"
 echo "     RELEASEDIR: $RELEASEDIR"  echo "     RELEASEDIR: $RELEASEDIR"
Line 518 
Line 540 
 #echo "       FILE_VER: $FILE_VER"  #echo "       FILE_VER: $FILE_VER"
 echo  echo
   
   for k in $INSTALL_KERNELS; do
       if [ -e "/$k" ]; then
           echo "Existing $k"
           kernel_file_version "/$k"
       fi
   done
   
 if [ ${_error} -ne 0 ]; then  if [ ${_error} -ne 0 ]; then
         exit ${_error}          exit ${_error}
 fi  fi
Line 528 
Line 557 
   
 check_sets || exit  check_sets || exit
   
 echo "Last booted:\n$BOOTED_KERNEL_VERSION"  echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"
 if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \  if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
   -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then    -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
     echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"      echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"
 fi  fi
 if [ -n "$NEW_KERNEL_VERSION" ]; then  if [ -n "$NEW_KERNEL_VERSION" ]; then
     echo "New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";      echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
 else  else
     echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2      echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2
     echo "ctrl+C to cancel, enter to continue anyway" >&2      echo "ctrl+C to cancel, enter to continue anyway" >&2
     local _temp      local _temp
     read _temp      read _temp
       NEW_KERNEL_VERSION=$BOOT_KERNEL_VERSION
 fi  fi
   
 if [ X"" != X"$SUDO" ]; then  if [ X"$NEW_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" ]; then
     echo Please enter your sudo password if prompted.      echo >&2
     echo You may be asked for it again later in the process.      echo "!!!  You are upgrading the OpenBSD kernel.        !!!" >&2
     $SUDO -v      echo "!!!  You will be given the opportunity to reboot  !!!" >&2
       echo "!!!  at the end of the proces but it is safer to  !!!" >&2
       echo "!!!  have a separate root shell open.             !!!" >&2
       echo "!!!  It is needed in order to run /sbin/oreboot.  !!!" >&2
       echo "!!!  sudo MAY NOT WORK after sets are extracted.  !!!" >&2
       echo >&2
       echo "enter to continue, ctrl+C to cancel" >&2
       local _temp
       read _temp
   
       if [ ! -e /sbin/oreboot ]; then
           cp /sbin/reboot /sbin/oreboot
           if [ $? -ne 0 ]; then
               echo "Error copying old reboot command!" >&2
               exit 1
           fi
           echo "/sbin/reboot copied to /sbin/oreboot"
       fi
 fi  fi
   
 install_kernels  install_kernels
 install_sets  install_sets
   
 if [ $CUR_VER == $NEW_VER ]; then  if [ X"$NEW_KERNEL_VERSION" == X"$BOOTED_KERNEL_VERSION" ]; then
       install_sendmail_smtp_auth
   
     if [ -e /sbin/oreboot ]; then      if [ -e /sbin/oreboot ]; then
         echo Removing /sbin/oreboot          echo Removing /sbin/oreboot
         $SUDO rm -f /sbin/oreboot          rm -f /sbin/oreboot
     fi      fi
     update_etc      update_etc
   
     echo '### UPDATING PACKAGES ###'      echo '==> UPDATING PACKAGES'
     $SUDO pkg_add -ui -F update -F updatedepends      pkg_add -ui -F update -F updatedepends
   
 else  else
     echo Instructions for updating to the new version available from      echo Instructions for updating to the new version available from
Line 570 
Line 619 
     fi      fi
 fi  fi
   
 echo New kernel installed.  Please reboot!  echo Update complete. enter to reboot, ctrl+C to cancel
   read _temp
 if [ -e /sbin/oreboot ]; then  if [ -e /sbin/oreboot ]; then
     echo Possibly using /sbin/oreboot      echo using /sbin/oreboot
 fi      /sbin/oreboot
   else
 local _send_dmesg=`dirname $0`/send_dmesg      /sbin/reboot
 if [ -e "$_send_dmesg" ]; then  
     if [ -e $RELEASEDIR/.send_dmesg ]; then  
         $_send_dmesg  
         rm -f $RELEASEDIR/.send_dmesg  
     elif [ X"$CUR_VER" != X"$NEW_VER" ]; then  
         touch $RELEASEDIR/.send_dmesg  
     fi  
 fi  fi

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.70

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>